
from direct.showbase.ShowBase import ShowBase
from direct.task import Task

from direct.gui.DirectGui import *
from panda3d.core import *
import csv
import time

from random import *
# import requests
import codecs
import PPLutilities as utils

mats = []

# Data = {}

firstTime = True

# this array holds the item number of the item from Data.data

class Topics(ShowBase):
	def __init__(self):

		self.modulename = "topics.Museum_data"
		# connect("images_loaded",roomnode, "restart_game")
		# not needed, kicked off by setting topic which is set off by requesting num images
		# fill_rooms()

		self.level = utils.level
		self.numWrong = utils.numWrong
		self.currentTopic = utils.topic
		self.numRows = utils.numRows
		self.numCols = utils.numCols

		self.imageQueue = []
		self.mazeImages = {}
		self.badInums = []

		self.rooms = {}
		self.wrongRooms = {}

		self.currentWalls = {}

		self.correctedWalls = []
		self.curInum = 0

		self.correctSound = base.loader.loadSfx("audio/correct-answer-2.ogg")
		self.wrongSound = base.loader.loadSfx("audio/incorrect-answer.ogg")

		self.playerNode = None
		self.accept('playerNode',self.setPlayer)
		self.accept('setTopic', self.set_topic)
		self.accept('newLevel',self.setLevel)
		self.accept('replace_item',self.change_wall_image)

	def setPlayer(self,pnode):
		print("Topics received player node")
		self.playerNode = pnode

	def cleanupOneRow(self,dataset):
		# print("row: "+str(dataset))
		dlab = "Description"
		if "description" in dataset:
			dlab = "description"
		ilab = "Image"
		if 'image' in dataset:
			ilab = 'image'
		alab = "Agent"
		if 'agent' in dataset:
			alab = 'agent'
		elif 'Actor' in dataset:
			alab = 'Actor'
		elif 'actor' in dataset:
			alab = 'actor'
		elif 'Who' in dataset:
			alab = 'Who'
		elif 'who' in dataset:
			alab = 'who'
		dalab = "Date"
		if 'date' in dataset:
			dalab = 'date'
		elif 'Number' in dataset:
			dalab = 'Number'
		elif 'number' in dataset:
			dalab = 'number'
		elif 'Count' in dataset:
			dalab = 'Count'
		elif 'count' in dataset:
			dalab = 'count'
		clab = "Credit"
		if 'credit' in dataset:
			clab = 'credit'
		cllab = "Clues"
		if 'clues' in dataset:
			cllab = 'clues'
		elif 'Objects' in dataset:
			cllab = 'Objects'
		elif 'objects' in dataset:
			cllab = 'objects'
		llab = "Location"
		if 'location' in dataset:
			llab = 'location'

		ret = None#{'description':"",'image':"",
			# "agent":"",
			# "date":"",
			# "credit":"",
			# "location":"",
			# "clues":""}
		if ilab in dataset:
			if len(str(dataset[ilab]))>5 and len(str(dataset[dlab]))>10:
				ret = {}
				print("image ok: "+str(dataset[ilab]))
				ret['description'] = dataset[dlab]
				ret['image'] = dataset[ilab]
				if alab in dataset:
					ret['agent'] = dataset[alab]
				else:
					ret['agent'] = ""
				ret['date'] = int(utils.extrDate(dataset[dalab]))
				if clab in dataset:
					ret['credit'] = dataset[clab]
				else:
					ret['credit'] = ""
				if llab in dataset:
					ret['location'] = dataset[llab]
				else:
					ret['location'] = ""
				if cllab in dataset:
					ret['clues'] = dataset[cllab]
				else:
					ret['clues'] = ""

		else:
			print("not valid: "+str(dataset))
		return ret

	def convRow2Dict(self,row,attrs):
		ret = {}
		for i in range(len(row)):
			ret[attrs[i]] =  row[i]

		return ret

	def setLevel(self,level):
		print("Topics received set level")
		# number wrong for each level
		self.level = level
		self.numWrong = utils.levels[int(level)]

	def set_topic(self,top):
		print("Topics received set topic")
		print("Topics getting topic: "+str(utils.topics[int(top)]))
		self.currentTopic = str(utils.topics[int(top)])
		self.modulename = "topics."+self.currentTopic+"_data"

		self.Data = []
		# tmpdat = requests.get("http://www.ideategames.org/museum/topics/"+self.currentTopic+'.csv')
		csvurl = "http://www.ideategames.org/museum/topics/"+self.currentTopic+'.csv'
		if utils.isHTML5:
			csvurl = "/working_museum.png"
		# 	# avoid browser security issue of http vs https from same server
		# 	csvurl = "topics/"+self.currentTopic+'.csv'
		utils.httpFetch(csvurl,self.currentTopic+'.csv',self.extractData)

	def extractData(self,datbuf):
		print("csv received: "+str(datbuf))
		# top = self.currentTopic
		# datbuf2 = codecs.iterdecode(datbuf.iter_lines(),'utf-8')
		# # with open("topics/"+self.currentTopic+'.csv', newline='', encoding='utf-8') as csvfile:
		# datreader = csv.reader(datbuf2, delimiter=',', quotechar='"')

		# rownum = 0
		# attrs = []
		# for row in datreader:
		# 	try:
		# 		if rownum<1:
		# 			for aname in row:
		# 				attrs.append(utils.getAttrTx(aname.lower()))
		# 		else:
		# 			tmp = self.cleanupOneRow(self.convRow2Dict(row,attrs))
		# 			if tmp:
		# 				self.Data.append(self.cleanupOneRow(self.convRow2Dict(row,attrs)))
		# 		rownum+=1
		# 	except:
		# 		pass

		# print("changing to: "+str(self.currentTopic))
		# messenger.send("reset",[top])
		# # NOTE: this csv reader puts the arrays by columns with the row second index
		# print("# Data items: "+str(len(self.Data)))
		# self.fill_rooms()
		# # delay = 0.25
		# # if firstTime:
		# # 	delay = 1.0
		# # 	firstTime = false
		# # # give time to be sure Room is fully loaded
		# # yield(get_tree().create_timer(delay),"timeout")
		# # # get_parent().find_node_by_name(get_parent(),"Room").restart_game()
		# messenger.send("dataNode",[self])
		# messenger.send('dataLoaded',[self])


	def cleanup_image(self,imgname):
		print("cleaning image: "+str(imgname))
		fname = utils.cleanImageName(imgname)
		# print("cleaned image: "+str(fname))
		return fname

	def get_numwrong(self):
		return self.numWrong

	def set_numwrong(self,num):
		self.numWrong = num

	def shuffleWrongs(self):
		# set aside the first correct value
		# a wrong room entry is "descr room":"image room"#"wall number"
		#	descr room is the room with the wrong image
		#	image room is the room that has the right image
		#	wall number is the wall number in both rooms
		used = []
		wrongWalls = []
		wrongCombo = []
		rnum = 1
		cnum = 1
		if self.level>0:
			rnum = randrange(self.numRows)
			cnum = randrange(self.numCols)
		wnum = randrange(4)
		roomnum = str(rnum)+str(cnum)
		print("first wrong room: "+str(roomnum)+"#"+str(wnum))
		wrongWalls = [str(wnum)]
		wrongCombo.append(roomnum+"#"+str(wnum)) 
		used.append(roomnum)
		# already have the first one
		for r in range(self.numWrong-1):
			rnum = randrange(self.numRows)
			cnum = randrange(self.numCols)
			roomnum = str(rnum)+str(cnum)
			while roomnum in used:
				rnum = randrange(self.numRows)
				cnum = randrange(self.numCols)
				roomnum = str(rnum)+str(cnum)
			print("wrong room: "+str(roomnum))
			# the wall number of the wrong room just identified
			wnum = randrange(4)
			# the previous wrong room will contain the 
			self.wrongRooms[used[-1]] = wrongWalls[-1]+"#"+roomnum+"#"+str(wnum)
			wrongWalls.append(str(wnum))
			wrongCombo.append(roomnum+"#"+str(wnum))
			used.append(roomnum)
		# print("adding wrong tail: "+str(used[-1])+":"+str(used[0]))
		self.wrongRooms[str(used[-1])] = wrongWalls[-1]+"#"+wrongCombo[0]

	def get_wrong(self,roomid):
		
		wrimg = self.rooms[roomid].copy()
		print("wallnums should be: "+str(roomid)+":"+str(wrimg))
		if roomid in self.wrongRooms:
			# for now, only 1 wrong wall in a room
			# format is thiswall : other room # other wall
			wrnum = self.wrongRooms[roomid]
			tmp = wrnum.split("#")
			thiswall = int(tmp[0])
			otherroom = tmp[1]
			otherwall = int(tmp[2])

			# room with the right image for rnum is wr[0]
			# wall that has the image that belongs somewhere else is in wr[1]
			print("room num from wrongRooms: "+roomid+":"+str(wrnum)+":"+str(thiswall)+":"+str(otherwall))
			wallnum = int(otherwall)
			wrimg[thiswall] = self.rooms[otherroom][otherwall]
			# print("mixed up room: "+str(wrnum)+":"+str(wallnum)+":"+str(wrimg[wallnum]))
		# return arrays of the image item numbers
		return wrimg

	def countErrors(self,dummy):
		count = 0
		for r in self.rooms:
			for w in range(4):
				if (self.rooms[r][w] != self.currentWalls[r][w]):
					count+=1
		# now we have the total number of errors
		# but let's see if the player cargo has one of the errors
		# badInums is an array of inums in the wrong place
		print("was it bad before? "+str(count)+":"+str(self.playerNode.getCargo())+":"+str(self.badInums))
		# if the cargo is not a bad item, then one more error
		if self.playerNode.getCargo():
			if int(self.playerNode.getCargo()) not in self.badInums:
				# credit for 1 good move if cargo has one of the items to be moved
				count +=1
		corrections = (utils.levels[self.level] + 1) - count
		print("num corrections: "+str(corrections))
		messenger.send("fixed_errors",[corrections])


	def wall_is_corrected(self,roomid,wnum,inum):
		ret = False
		if roomid in self.wrongRooms:
			tmp = self.wrongRooms[roomid].split("#")
			if int(wnum) == int(tmp[0]):
				print("testing correct: "+str(inum)+":"+str(self.currentWalls[roomid][wnum])+":"+str(self.rooms[roomid][wnum]))
				print("t1: "+str( (inum == None) and (self.currentWalls[roomid][wnum]!=self.rooms[roomid][wnum]) ))
				print("t2: "+str( (self.currentWalls[roomid][wnum]==None) and (inum==self.rooms[roomid][wnum]) ))
				print("t3: "+str(inum==self.rooms[roomid][wnum]))
				# 3 good conditions: wall is wrong and cargo is empty; wall is empty and cargo is correct; wall is wrong and cargo is right
				if ((inum == None) and (self.currentWalls[roomid][wnum]!=self.rooms[roomid][wnum])) or\
				((self.currentWalls[roomid][wnum]==None) and (inum==self.rooms[roomid][wnum])) or\
				(inum==self.rooms[roomid][wnum]):
					ret = True
		return ret

	def change_wall_image(self,roomid,wnum,inum):
		# roomid = str(roomarr[0])+str(roomarr[1])
		correct = self.wall_is_corrected(roomid,wnum,inum)
		if correct:
			self.correctSound.play()
			# be sure walls are updated
		else:
			self.wrongSound.play()
			base.numMistakes = base.numMistakes + 1
		print("putting into currentWalls: "+roomid+":"+str(wnum)+":"+str(inum))
		self.currentWalls[roomid][wnum] = inum
		taskMgr.doMethodLater(1.0, self.countErrors,"Count Errors")


	def get_wall_inum(self,roomid,wnum):
		# roomid = str(roomarr[0])+str(roomarr[1])
		print("in get wall: "+str(roomid)+":"+str(wnum))
		# ret = self.rooms[roomid][wnum]
		# if roomid in self.currentWalls:
		# 	print("self.currentWalls: "+str(self.currentWalls[roomid]))
		# 	if wnum in self.currentWalls[roomid]:
		# 		ret = self.currentWalls[roomid][wnum]
		# if roomid in self.wrongRooms:
		# 	tmp = self.wrongRooms[roomid]
		# 	# print("getting wall inum1: "+str(tmp))
		# 	tmp2 = tmp.split("#")
		# 	# print("getting wall inum: "+str(tmp2[0]+":"+str(tmp2[1])))
		# 	if str(tmp2[1])==str(wnum):
		# 		ret = self.rooms[str(tmp2[0])][int(tmp2[1])]

		return self.currentWalls[roomid][wnum]

	def get_room_data(self,roomid):
		
		# rnum = str(roomid[0])+str(roomid[1])
		# a wrong room entry is "descr room":"image room"#"wall number"
		#	descr room is the room with the wrong image
		#	image room is the room that has the right image
		#	wall number is the wall number in both rooms

		# description is always correct, but image could be wrong
		# loop for 4 walls
		# all arrays are strings
		rimages = [0,0,0,0]
		rdescrs = ["","","",""]
		rdescrs2 = ["","","",""]
		# wallexcept = self.get_wrong(roomid)
		print("wall inums assigned: "+roomid+":"+str(self.currentWalls[roomid]))
		print("wall inums correct: "+roomid+":"+str(self.rooms[roomid]))
		for w in range(4):
			inum = self.rooms[roomid][w]
			inum2 = self.currentWalls[roomid][w] #wallexcept[w]
			# print("getting image and descr that should not match in one case: "+str(inum)+":"+str(inum2))
			# image is the one what is wrong; description is always correct
			rimages[w] = inum2 #get_image(inum2)
			rdescrs[w] = self.get_descr(inum)
			attr = "date"
			rdescrs2[w] = "Date: "+str(self.get_attr(inum,attr))
			attr = "location"
			rdescrs2[w] = rdescrs2[w] +"\n"+ "Location: " + self.get_attr(inum,attr)
			attr = "agent"
			# print("skip data: "+self.currentTopic+":"+str(utils.skip[self.currentTopic]))
			if "agent" not in utils.skip[self.currentTopic]:
				rdescrs2[w] = rdescrs2[w] +"\n"+ "Agent: " + self.get_attr(inum,attr)
			attr = "credit"
			rdescrs2[w] = rdescrs2[w] +"\n"+ "Image credit: " + self.get_attr(inum,attr)

		return [rimages,rdescrs,rdescrs2]

	def wall_is_wrong(self,roomid,wnum):
		ret = False
		if roomid in self.wrongRooms:
			tmp = self.wrongRooms[roomid].split("#")
			if str(wnum)==str(tmp[0]):
				ret = True

		return ret

	def replace_is_wrong(self,roomarr,wallid,inum):
		
		ret
		# just to be square
		wnum = int(wallid)
		# is this replacing a wrong wall with a correct image?
		roomid = str(roomarr[0])+str(roomarr[1])
		if roomid in self.wrongRooms:
			print("room has a wrong item")
			tmp = self.wrongRooms[roomid].split("#")
			targwall = int(tmp[1])
			shouldbe = int(self.rooms[roomid][wnum])
			print("room has a wrong item: "+str(targwall)+":"+str(wnum)+":"+str(shouldbe)+":"+str(inum))
			if shouldbe==inum and targwall==wnum:
				if not (roomid in self.correctedWalls):
					self.correctedWalls.append(roomid)
				ret = true
			else:
				print("room has a mistake, but not correct item for this wall")
		return ret

	def fill_rooms(self):
		print("filling rooms")
		used = []
		self.rooms = {}
		self.wrongRooms = {}
		self.imageQueue =[]
		for mi in self.mazeImages:
			try: 
				self.mazeImages[mi][0].destroy()
				self.mazeImages[mi][0] = None
				self.mazeImages[mi] = None
			except: pass
		self.mazeImages = {}
		self.currentWalls = {}
		self.badInums = []
		dateArr ={}
		# this shuffles the random number starting location
		seed()

		# print("self.Data in fill_rooms: "+str(self.Data))
		numimg = self.get_numimages()
		# for r in self.rooms:
		walli = []
		for w in range(36):
			inum = randrange(numimg)
			# print("inum: "+str(numimg)+":"+str(inum)+":"+str(self.Data[inum]))
			print("next rando: "+str(inum)+":"+str(self.Data[inum]['image']))
			while inum in used:
				inum = randrange(numimg)
			used.append(inum)
			self.imageQueue.append([inum,self.cleanup_image(self.get_image(inum))])
			# to sort by date, need to save in data array first
			dat = int(self.get_attr(inum,"date"))
			# print("date received: "+str(dat))
			if not (dat in dateArr):
				dateArr[dat] = []
			dateArr[dat].append(inum)

		# keys = dateArr.keys()
		# keys.sort()
		# print("date keys: "+str(keys))
		r = 0
		w = 0
		for k in sorted (dateArr.keys()):
			for d2 in dateArr[k]:
				if w>3:
					r +=1
					w = 0
				roomid = utils.roomOrder[r]
				# print("room: "+str(roomid)+":"+str(w))
				if not (roomid in self.rooms):
					self.rooms[roomid] = []
				self.rooms[roomid].append(d2)
				w += 1
		print("rooms: "+str(self.rooms))
		self.shuffleWrongs()
		for r in self.rooms:
			self.currentWalls[r] = self.rooms[r].copy()
		for ww in self.wrongRooms:
			tmp = self.wrongRooms[ww].split("#")
			print("adjusting room: "+str(ww)+":"+tmp[1]+":"+str(tmp[2])+":"+str(self.rooms[tmp[1]][int(tmp[2])]))
			self.currentWalls[ww][int(tmp[0])] = self.rooms[tmp[1]][int(tmp[2])]
			self.badInums.append(self.rooms[tmp[1]][int(tmp[2])])
		print("wrong rooms: "+str(self.wrongRooms))
		print("current rooms: "+str(self.currentWalls))
		self.load_image_queue("dummy")


	def get_room_item(self,roomid):
		# print("getting room: "+str(roomid))
		return self.rooms[roomid]

	def get_num_correct(self):
		return len(self.correctedWalls)

	def get_numimages(self):
		if "description" in self.Data[0]:
			print("description 0: "+str(len(self.Data[0]['description'])))
		else:
			print("Data seems to be empty!")
			# self.set_topic(self.currentTopic)
		return len(self.Data)

	def get_image(self,inum):
		print("image: "+str(self.Data[inum]['image']))
		return self.Data[inum]['image']

	def get_descr(self,inum):
		attr = "date"
		rdescrs2 = "Date: "+str(self.get_attr(inum,attr))
		attr = "location"
		rdescrs2 = rdescrs2 +"\n"+ "Location: " + self.get_attr(inum,attr)
		attr = "agent"
		if "agent" not in utils.skip[self.currentTopic]:
			rdescrs2 = rdescrs2 +"\n"+ "Agent: " + self.get_attr(inum,attr)
		attr = "credit"
		rdescrs2 = rdescrs2 +"\n"+ "Image credit: " + self.get_attr(inum,attr)
		return self.Data[inum]["description"]+"\n===================================\n"+rdescrs2

	def get_attr(self,inum,attr):
		return self.Data[inum][attr]

	def get_room_range(self,roomid):
		
		rdat = self.rooms[roomid]
		sdat = self.get_attr(rdat[0],"date")
		edat = self.get_attr(rdat[3],"date")
		return [sdat,edat]

	# Called every frame. 'delta' is the elapsed time since the previous frame.
	#def _process(delta):
	#	pass

	# pseudo-listener, for when this becomes async
	def load_image_from_queue(self,response):

		p = PNMImage()
		p.read(StringStream(response))
		xsize = p.getReadXSize()
		ysize = p.getReadYSize()

		self.mazeImages[self.curInum] = []#Texture()
		self.mazeImages[self.curInum].append(Texture())
		self.mazeImages[self.curInum][-1].load(p)
		self.mazeImages[self.curInum].append(xsize)
		self.mazeImages[self.curInum].append(ysize)
		sofar = len(self.mazeImages.keys())
		messenger.send("progress",[sofar])
		# game.set_progress(36-len(self.imageQueue))
		taskMgr.doMethodLater(0.1, self.load_image_queue, 'Next Image')

	def load_image_queue(self,dummy):
		if len(self.imageQueue)>0:
			imgdat = self.imageQueue.pop()
			self.curInum = imgdat[0]
			fname = imgdat[1]

			# print("fetching image: "+imgname)
			# response = requests.get("http://www.ideategames.org/dcims/"+imgdat[1])
			utils.httpFetch("http://www.ideategames.org/dcims/"+fname,fname,self.load_image_from_queue)
			# call the listener to fake async
			# self.load_image_from_queue(response)
		else:
			print("starting game")
			messenger.send("images_loaded")

	def get_preload(self,inum):
		ret = None
		if inum:
			if inum in self.mazeImages:
				ret = self.mazeImages[inum]
		return ret

# APP = Topics()
